<?php

class Verifone_VerifonePayment_Block_Adminhtml_Config_PaymentsgroupsArray extends Mage_Adminhtml_Block_System_Config_Form_Field_Array_Abstract
{
    protected $magentoAttributes;
    protected $_editOrder;

    public function __construct()
    {
        $this->addColumn('position', array(
            'label' => $this->helper('VerifonePayment')->__('Group Position'),
            'size' => 2,
            'style' => 'width: auto'
        ));

        $this->addColumn('group_name', array(
            'label' => $this->helper('VerifonePayment')->__('Group name'),
            'size' => 30,
            'style' => 'width: auto',
        ));

        $this->addColumn('payments', array(
            'label' => $this->helper('VerifonePayment')->__('Payments'),
            'size' => 10,
            'style' => 'width: auto'
        ));

        $this->_addAfter = false;
        $this->_editOrder = true;
        $this->_addButtonLabel = $this->helper('VerifonePayment')->__('Add new group');
        parent::__construct();
        $this->setTemplate('VerifonePayment/system/config/form/field/array.phtml');
    }

    protected function _prepareLayout() {
        parent::_prepareLayout();
        if (Mage::getSingleton('cms/wysiwyg_config')->isEnabled()) {
            $this->getLayout()->getBlock('head')->setCanLoadTinyMce(true);
        }
    }

    protected function _renderCellTemplate($columnName)
    {
        if (empty($this->_columns[$columnName])) {
            throw new Exception('Wrong column name specified.');
        }
        $column = $this->_columns[$columnName];
        $inputName = $this->getElement()->getName() . '[#{_id}][' . $columnName . ']';
        if ($columnName == 'payments') {
            $payments = $this->renderPayments();

            $column['size'] = $column['size'] > count($payments) ? count($payments) : $column['size'];

            $rendered = '<select name="' . $inputName . '[]" id="select_' . $columnName . '#{_id}" size="' . $column['size'] . '" multiple="multiple">';

            foreach ($payments as $_option) {
                $rendered .= '<option value="' . $_option['value'] . '">' . $_option['label'] . '</option>';
            }

            $rendered .= '</select>';
            return $rendered;
        } elseif ($columnName == 'group_name') {
            $rendered = '<input type="text" name="' . $inputName . '" value="#{' . $columnName . '}" ' .
                'id="textfield_' . $columnName . '#{_id}"' .
                ($column['size'] ? 'size="' . $column['size'] . '"' : '') . ' class="' .
                (isset($column['class']) ? $column['class'] : 'input-text') . '"' .
                (isset($column['style']) ? ' style="' . $column['style'] . '"' : '') . '/>';

            $rendered .= '<input type="checkbox" name="' . $inputName . '" id="checkbox_' . $columnName . '#{_id}" value="' . $this->helper('VerifonePayment')->getGroupForDefaultView() . '" />';
            $rendered .= '<label for="checkbox_' . $columnName . '#{_id}"">' . $this->helper('VerifonePayment')->__('Show those without groups') . '</label>';

            return $rendered;
        }

        if ($column['renderer']) {
            return $column['renderer']->setInputName($inputName)->setColumnName($columnName)->setColumn($column)
                ->toHtml();
        }
        return '<input type="text" name="' . $inputName . '" value="#{' . $columnName . '}" ' .
        ($column['size'] ? 'size="' . $column['size'] . '"' : '') . ' class="' .
        (isset($column['class']) ? $column['class'] : 'input-text') . '"' .
        (isset($column['style']) ? ' style="' . $column['style'] . '"' : '') . '/>';
    }

    protected function renderPayments()
    {
        $_db = Mage::getModel('VerifonePayment/db_pay_options');
        return $_options = $_db->toOptionArray();
    }

}