<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_VerifonePayment_Block_Adminhtml_GenerateKeys extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('VerifonePayment/generate_keys.phtml');
        }
        return $this;
    }

    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    public function getConfirmationMessage()
    {

        $m1 = Mage::helper('VerifonePayment')->__('Are you sure you want to generate keys? The keys are stored in database.');
        $m2 = Mage::helper('VerifonePayment')->__('After creating a new key, remember to copy this key to payment operator configuration settings, otherwise the payment will be broken');

        return sprintf("%s\\n\\n%s", $m1, $m2);
    }

    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        $originalData = $element->getOriginalData();
        $this->addData(array(
            'button_label' => Mage::helper('customer')->__($originalData['button_label']),
            'html_id' => $element->getHtmlId(),
            'ajax_url' => Mage::getSingleton('adminhtml/url')->getUrl('*/verifone_generateKeys')
        ));

        return $this->_toHtml();
    }

    public function getTestDescription()
    {
        return Mage::helper('VerifonePayment')->__('Uses preset keys by default, only needed if using custom test agreements');
    }

    public function getTestButtonLabel()
    {
        return Mage::helper('VerifonePayment')->__('Generate test keys');
    }

    public function getLiveDescription()
    {
        return Mage::helper('VerifonePayment')->__('When you generate live keys, you will need to upload the new public key to Verifone Payment portal');
    }

    public function getLiveButtonLabel()
    {
        return Mage::helper('VerifonePayment')->__('Generate live keys');
    }

}