<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2019 Lamia Oy (https://lamia.fi)
 */


class Verifone_VerifonePayment_Block_Adminhtml_ReadonlyText extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {

        $path = $this->_getPath($element);

        $element->setValue($this->_getDefaultValue($path));
        $element->setReadonly(true);

        return parent::_getElementHtml($element);
    }

    protected function _getPath($element)
    {
        return str_replace('_', '/', $element->getId());
    }

    protected function _getDefaultValue($path)
    {
        return Mage::getConfig()
            ->loadModulesConfiguration('config.xml')
            ->getNode('default/' . $path);
    }

}