<?php

class Verifone_VerifonePayment_Block_Catalog_Product_Price extends Mage_Catalog_Block_Product_Price
{

    public function getProduct()
    {
        $product = $this->_getData('product');
        if (!$product) {
            $product = Mage::registry('product');
        }
        return $product;
    }

    protected function _toHtml()
    {
        if (!$this->getProduct() || $this->getProduct()->getCanShowPrice() === false) {
            return '';
        }

        return $this->switchPrice($this->getProduct(), parent::_toHtml());
    }

    protected function switchPrice($_product, $htmlPrice)
    {
        if ( Mage::getStoreConfig('payment/VerifonePayment/add_period_to_price_html') && $_product->isRecurring() ) {

            $_recurring = Mage::getModel('catalog/product')->load($_product->getId());

            $_profile = $_recurring->getReurringProfile();

            $period = $_profile['period_unit'];
            $period .= $_profile['period_frequency'] != '1' ? 's' : '';

            $html = '';
            $i = 0;
            foreach (explode('<span class="price"', $htmlPrice) as $partToProcess) {
                if ($i++) {
                    $html .= '<span class="price"' . preg_replace('/<\/span>/', ' / ' . $this->helper('VerifonePayment')->__($period) . '</span>', $partToProcess, 1);
                } else {
                    $html .= $partToProcess . '<span class="price"';
                }

            }
            return $html;
        }
        return $htmlPrice;
    }

}
