<?php

class Verifone_VerifonePayment_Model_Api_S2s_RefundPayment extends Verifone_VerifonePayment_Model_Api_S2s_Abstract
{
    protected $_order;
    protected $_price;


    public function prepareData()
    {

        if (is_null($this->_fields)) {
            $this->_fields = array();
        }

        $_helper = Mage::helper('VerifonePayment');
        $_helperConfiguration = Mage::helper('VerifonePayment/configuration');

        $_storeId = $this->getOrder()->getStoreId();

        $_fields = array(
            's-f-1-30_operation' => 'refund-payment', //this value is obligatory but it would be filled in every method
            't-f-14-19_request-timestamp' => gmdate('Y-m-d H:i:s'),
            's-f-1-36_merchant-agreement-code' => $_helperConfiguration->getMerchantAgreement($_storeId),
            's-f-1-30_software' => 'Magento',
            's-f-1-10_software-version' => $_helper->_sanitise(Mage::getVersion(), 10, true),

            //important difference
            'i-f-1-11_interface-version' => '3',

            'l-f-1-20_transaction-number' => $this->getOrder()->getExtOrderId(),
            's-f-1-30_payment-method-code' => $this->getOrder()->getVerifonePaymentMethod(),
            'i-f-1-3_refund-currency-code' => $_helper->convertCountryToISO4217($this->getOrder()->getOrderCurrency()->getCurrencyCode()),
            'l-f-1-20_refund-amount' => preg_replace("/[^0-9]/", "", $this->getPrice()),
            's-t-1-36_order-note' => 'Refund Request'
        );

        $this->_fields = array_merge($this->_fields, $_fields);

        $this->addRefundProduct();
        $this->setStoreId($_storeId);

        return parent::prepareData();
    }

    public function addRefundProduct()
    {
        if (null === $this->_fields) {
            $this->_fields = array();
        }

        $_refundProduct = array(
            's-t-1-30_bi-name-0' => 'Refund',
            'i-t-1-11_bi-unit-count-0' => '1',
            'l-t-1-20_bi-unit-cost-0' => $this->_price,
            'l-t-1-20_bi-net-amount-0' => $this->_price,
            'l-t-1-20_bi-gross-amount-0' => $this->_price,
            'i-t-1-4_bi-vat-percentage-0' => 0,
            'i-t-1-4_bi-discount-percentage-0' => 0,
        );

        $this->_fields = array_merge($this->_fields, $_refundProduct);

        return $this;
    }

    public function setOrder($_order)
    {
        if ($_order) {
            $this->_order = $_order;
        }

        return $this;
    }

    /**
     * @return Mage_Sales_Model_Order
     */
    protected function getOrder()
    {
        return $this->_order;
    }

    public function setPrice($_price)
    {
        if ($_price) {
            $this->_price = $_price;
        }

        return $this;
    }

    protected function getPrice()
    {
        return $this->_price;
    }

}