<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_VerifonePayment_Adminhtml_Verifone_GenerateKeysController extends Mage_Adminhtml_Controller_Action
{
    public function indexAction()
    {

        if (!empty($code = Mage::app()->getRequest()->getParam('website'))) // website level
        {
            $scope = 'websites';
            $scopeId = Mage::getModel('core/website')->load($code)->getId();
        } else {
            // default level
            $scope = 'default';
            $scopeId = 0;
        }

        $helper = Mage::helper('VerifonePayment/keyGenerator');

        $success = true;
        $messages = array();
        $mode = $this->getRequest()->getParam('mode');

        if (empty($mode)) {
            $success = false;
            $messages[] = $helper->__('Problem with generating new keys. ') . $helper->__('Please refresh the page and try again.');
        }

        if (!$success) {
            return $this->_returnJson($success, $messages);
        }

        $resultGenerate = $helper->generateKeys();

        if ($resultGenerate) {
            $resultStoreKey = Mage::helper('VerifonePayment/keys')->storeKeysIntoDatabase($scope, $scopeId, $mode, $helper);

            if ($resultStoreKey === true) {
                $messages[] = $helper->__('Keys are generated correctly. Please refresh the page.');
                Mage::app()->getCacheInstance()->cleanType('config');
                return $this->_returnJson(true, $messages);
            }

            $success = false;
            $messages[] = $resultStoreKey;

        } else {
            $success = false;
            $messages[] = $helper->__('Problem with generating new keys.');
        }

        return $this->_returnJson($success, $messages);
    }

    protected function _returnJson($success, $messages)
    {

        $params = array('success' => $success, 'messages' => $messages);

        $this->getResponse()->clearHeaders()->setHeader('Content-type', 'application/json', true);

        if (is_array($params)) {
            $params = json_encode($params);
        }

        $this->getResponse()->setBody($params);

    }
}