<?php


class Verifone_VerifonePayment_Adminhtml_Verifone_Sales_OrderController extends Mage_Adminhtml_Controller_Action
{
    public function checkStatusAction()
    {
        if (!$_orderIncrementId = $this->getRequest()->getParam('order_increment_id')) {
            return $this->_redirect('*/sales_order/view', $this->getRequest()->getParams());
        }

        $_helper = Mage::helper('VerifonePayment');
        $session = Mage::getSingleton('core/session');

        try {

            $transactions = Mage::getModel('VerifonePayment/payment')->getTransactions($_orderIncrementId, $update = true);

            if (!$transactions || empty($transactions)) {
                $session->addNotice($_helper->__('No changes in payment for this order'));
            }

        } catch (Exception $e) {

            $session->addError($e->getMessage());

        }

        return $this->_redirect('*/sales_order/view', $this->getRequest()->getParams());
    }

    protected function _isAllowed()
    {
        return Mage::getSingleton('admin/session')->isAllowed('VerifonePayment/check_payment_status');
    }
}
