<?php

/** @var $this Mage_Catalog_Model_Resource_Setup */

$installer = $this;
$installer->startSetup();

$table = $installer->getConnection()
    ->newTable($installer->getTable('VerifonePayment/pay_options'))
    ->addColumn('id', Varien_Db_Ddl_Table::TYPE_SMALLINT, null, array(
        'identity' => true,
        'unsigned' => true,
        'nullable' => false,
        'primary' => true,
    ), 'Id')
    ->addColumn('code', Varien_Db_Ddl_Table::TYPE_TEXT, 50, array(
        'nullable' => false,
    ), 'payment method code')
    ->addColumn('name', Varien_Db_Ddl_Table::TYPE_TEXT, 50, array(
        'nullable' => false,
    ), 'payment method type')
    ->addColumn('type', Varien_Db_Ddl_Table::TYPE_TEXT, 50, array(
        'nullable' => false,
    ), 'type of payment')
    ->addColumn('active', Varien_Db_Ddl_Table::TYPE_BOOLEAN, null, array(
        'nullable' => false,
        'default' => '0'
    ), 'is payment active');

$installer->getConnection()->createTable($table);


$data = array(
    array('code' => 'VerifonePayment', 'name' => 'VerifonePayment - All in one', 'type' => 'ALL', 'active' => '1'),
    array('code' => 'visa', 'name' => 'Visa', 'type' => 'CARD'),
    array('code' => 'master-card', 'name' => 'Master Card', 'type' => 'CARD'),
    array('code' => 's-pankki-verkkomaksu', 'name' => 'S_PANKKI_VERKKOMAKSU', 'type' => 'BANK'),
    array('code' => 'aktia-maksu', 'name' => 'AKTIA_MAKSU', 'type' => 'BANK'),
    array('code' => 'op-pohjola-verkkomaksu', 'name' => 'OP_POHJOLA_VERKKOMAKSU', 'type' => 'BANK'),
    array('code' => 'nordea-e-payment', 'name' => 'NORDEA_E_PAYMENT', 'type' => 'BANK'),
    array('code' => 'sampo-web-payment', 'name' => 'SAMPO_WEB_PAYMENT', 'type' => 'BANK'),
    array('code' => 'tapiola-verkkomaksu', 'name' => 'TAPIOLA_VERKKOMAKSU', 'type' => 'BANK'),
    array('code' => 'handelsbanken-e-payment', 'name' => 'HANDELSBANKEN_E_PAYMENT', 'type' => 'BANK'),
    array('code' => 'alandsbanken-e-payment', 'name' => 'ALANDSBANKEN_E_PAYMENT', 'type' => 'BANK'),
    array('code' => 'nordea-se-db', 'name' => 'NORDEA_SE_DB', 'type' => 'BANK'),
    array('code' => 'handelsbanken-se-db', 'name' => 'HANDELSBANKEN_SE_DB', 'type' => 'BANK'),
    array('code' => 'swedbank-se-db', 'name' => 'SWEDBANK_SE_DB', 'type' => 'BANK'),
    array('code' => 'seb-se-db', 'name' => 'SEB_SE_DB', 'type' => 'BANK'),
    array('code' => 'invoice-collector', 'name' => 'INVOICE_COLLECTOR', 'type' => 'INVOICE'),
    array('code' => 'bank-axess', 'name' => 'BANK_AXESS', 'type' => 'BANK'),
    array('code' => 'dankort', 'name' => 'DANKORT', 'type' => 'CARD'),
    array('code' => 'nordea-dk-db', 'name' => 'NORDEA_DK_DB', 'type' => 'BANK'),
    array('code' => 'danske-netbetaling', 'name' => 'DANSKE_NETBETALING', 'type' => 'BANK'),
    array('code' => 'handelsbanken-se-invoice', 'name' => 'HANDELSBANKEN_SE_INVOICE', 'type' => 'INVOICE'),
    array('code' => 'amex', 'name' => 'American Express', 'type' => 'CARD'),
    array('code' => 'diners', 'name' => 'DINERS', 'type' => 'CARD'),
    array('code' => 'handelsbanken-se-account', 'name' => 'HANDELSBANKEN_SE_ACCOUNT', 'type' => 'INVOICE'),
    array('code' => 'svea-webpay-invoice', 'name' => 'SVEA_WEBPAY_INVOICE', 'type' => 'INVOICE'),
    array('code' => 'svea-webpay-installment', 'name' => 'SVEA_WEBPAY_INSTALLMENT', 'type' => 'INVOICE')
);

foreach ($data as $bind) {
    $installer->getConnection()->insertForce($installer->getTable('VerifonePayment/pay_options'), $bind);
}

$installer->endSetup();