<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_VerifonePayment_Helper_KeyGenerator extends Mage_Core_Helper_Abstract
{
    const BITS = 1024;

    protected $_privateKey = null;
    protected $_publicKey = null;

    public function generateKeys()
    {
        try {

            set_include_path(get_include_path() . PATH_SEPARATOR . dirname(__FILE__));
            require_once('Crypt/RSA.php');
            $rsa = new Crypt_RSA();

            $keyPair = $rsa->createKey(self::BITS);
            $this->setKeys($keyPair['publickey'], $keyPair['privatekey']);
        } catch (\Exception $e) {
            return false;
        }
        return true;
    }

    public function setKeys($publicKey, $privateKey)
    {
        $this->_publicKey = $publicKey;
        $this->_privateKey = $privateKey;
    }

    /**
     * @return string
     */
    public function getPrivateKey()
    {
        return $this->_privateKey;
    }

    /**
     * @return string
     */
    public function getPublicKey()
    {
        return $this->_publicKey;
    }

}