<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_VerifonePayment_Helper_Keys extends Mage_Core_Helper_Abstract
{
    /**
     * @param string $scope
     * @param int $scopeId
     * @param string $mode
     * @param Verifone_VerifonePayment_Helper_KeyGenerator $keys
     * @return bool
     */
    public function storeKeysIntoDatabase($scope, $scopeId, $mode, $keys)
    {
        try {
            if ($mode === 'live') {
                Mage::getConfig()->saveConfig('payment/VerifonePayment/keys_live_public', $keys->getPublicKey(), $scope, $scopeId);
                Mage::getConfig()->saveConfig('payment/VerifonePayment/keys_live_private', $keys->getPrivateKey(), $scope, $scopeId);
            } else {
                Mage::getConfig()->saveConfig('payment/VerifonePayment/keys_test_public', $keys->getPublicKey(), $scope, $scopeId);
                Mage::getConfig()->saveConfig('payment/VerifonePayment/keys_test_private', $keys->getPrivateKey(), $scope, $scopeId);
            }
        } catch (Exception $e) {
            return false;
        }

        return true;
    }

    public function getLivePrivateKey($storeId = null)
    {
        return Mage::getStoreConfig('payment/VerifonePayment/keys_live_private', $storeId);
    }

    public function getLivePublicKey($storeId = null)
    {
        return Mage::getStoreConfig('payment/VerifonePayment/keys_live_public', $storeId);
    }

    public function getTestPrivateKey($storeId = null)
    {
        return Mage::getStoreConfig('payment/VerifonePayment/keys_test_private', $storeId);
    }

    public function getTestPublicKey($storeId = null)
    {
        return Mage::getStoreConfig('payment/VerifonePayment/keys_test_public', $storeId);
    }
}