<?php

/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2017 Lamia Oy (https://lamia.fi)
 * @author    Szymon Nosal <simon@lamia.fi>
 */
class Verifone_VerifonePayment_Helper_Order extends Mage_Core_Helper_Abstract
{

    public function uncancelOrder(Mage_Sales_Model_Order $order)
    {
        /** @var Mage_Sales_Model_Order_Item $item */
        foreach ($order->getAllItems() as $item) {
            $this->reduceStockQty($item);
            $item->setQtyCanceled(0);
            $item->setTaxCanceled(0);
            $item->setHiddenTaxCanceled(0);
            $item->save();
        }

        $state = Mage_Sales_Model_Order::STATE_NEW;
        $status = $status = Mage::getModel('sales/order_status')->loadDefaultByState($state);

        // restoring the order itself.
        $order->setBaseDiscountCanceled(0)
            ->setBaseShippingCanceled(0)
            ->setBaseSubtotalCanceled(0)
            ->setBaseTaxCanceled(0)
            ->setBaseTotalCanceled(0)
            ->setDiscountCanceled(0)
            ->setShippingCanceled(0)
            ->setSubtotalCanceled(0)
            ->setTaxCanceled(0)
            ->setTotalCanceled(0)
            ->setState($state)
            ->setStatus($status->getData('status'))
            ->save();
    }

    /**
     * @param Mage_Sales_Model_Order_Item $_item
     */
    protected function reduceStockQty($_item)
    {
        $_canceledQty = $_item->getQtyCanceled();

        if (!$_canceledQty) {
            return;
        }

        $productId = $_item->getProductId();
        $product = Mage::getModel('catalog/product')->load($productId);
        $stock_obj = Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId);
        $stockData = $stock_obj->getData();
        $product_qty_before = (int)$stock_obj->getQty();
        $product_qty_after = (int)($product_qty_before - $_canceledQty);
        $stockData['qty'] = $product_qty_after;

        if ($product_qty_after >= 0) {
            $stockData['is_in_stock'] = 1;
        } else {
            $stockData['is_in_stock'] = 0;
        }

        $productInfoData = $product->getData();
        $product->setData($productInfoData);
        $product->setStockData($stockData);
        $product->save();
    }

}