<?php

class Verifone_VerifonePayment_Helper_Payment_Data extends Mage_Payment_Helper_Data
{
    protected $_veriGroups;

    public function getStoreMethods($store = null, $quote = null)
    {
        $res = array();
        foreach ($this->getPaymentMethods($store) as $code => $methodConfig) {
            $prefix = self::XML_PATH_PAYMENT_METHODS . '/' . $code . '/';
            if (!$model = Mage::getStoreConfig($prefix . 'model', $store)) {
                continue;
            }
            $methodInstance = Mage::getModel($model);
            if (!$methodInstance) {
                continue;
            }


            $methodInstance->setStore($store);
            if (!$methodInstance->isAvailable($quote)) {
                /* if the payment method cannot be used at this time */
                continue;
            }

            $sortOrder = (float)$methodInstance->getConfigData('sort_order', $store);
            $methodInstance->setSortOrder($sortOrder);

            if (is_a($methodInstance, 'Verifone_VerifonePayment_Model_Payment')) {
                $sortOrder = (float)Mage::getStoreConfig('payment/VerifonePayment/sort_order', $store);

                $_prefix = is_a($methodInstance, 'Verifone_VerifonePayment_Model_Payment_Recurring') ? 'vp-recurring_' : 'vp_';

                $_sortOrdersArr = $this->getVerifonePaymentGroups(str_replace($_prefix, "", $methodInstance->getCode()));

                foreach ($_sortOrdersArr as $_groupId => $_itemSortOrder) {
                    $methodInstance->setSortOrder($sortOrder + $_itemSortOrder);
                    $methodInstance->setVerifoneGroupId($_groupId);
                }

            }
            $res[] = $methodInstance;
        }

        usort($res, array($this, '_sortMethods'));
        return $res;
    }

    protected function _sortMethods($a, $b)
    {
        if (is_object($a)) {
            return (float)$a->sort_order < (float)$b->sort_order ? -1 : ((float)$a->sort_order > (float)$b->sort_order ? 1 : 0);
        }
        return 0;
    }

    public function getVerifonePaymentGroups($_gateCode)
    {
        if (is_null($this->_veriGroups)) {
            $_cardsPayments = unserialize(Mage::getStoreConfig('payment/VerifonePayment/cardpaymentsgroup_array'));
            $_customGroupsPayments = unserialize(Mage::getStoreConfig('payment/VerifonePayment/paymentsgroups_array'));

            $this->_veriGroups = array_merge($_customGroupsPayments, $_cardsPayments);
        }

        $_sortOrdersArr = array();

        $_groups = $this->_veriGroups;

        foreach ($_groups as $_id => $_group) {
            if (($key = array_search($_gateCode, $_group['payments'])) !== false) {
                $_groupPosition = (float)$_group['position'] / 1000;
                $_paymentPosition = $key / 100000;
                $_sortOrdersArr[$_id] = ($_groupPosition + $_paymentPosition);
            }
        }

        return $_sortOrdersArr;
    }

    public function getVerifoneCodes()
    {
        if (!Mage::getStoreConfig('payment/VerifonePayment/active')) {
            return array();
        }

        return explode(',', Mage::getStoreConfig('payment/VerifonePayment/payment_codes'));

    }
}