<?php

class Verifone_VerifonePayment_Model_Api_S2s_GetPaymentStatus extends Verifone_VerifonePayment_Model_Api_S2s_Abstract
{
    protected $_paymentMethodCode;
    protected $_transactionNumber;

    public function prepareData()
    {
        $_helper = Mage::helper('VerifonePayment');
        $_helperConfiguration = Mage::helper('VerifonePayment/configuration');

        $_fields = array(
            's-f-1-30_operation' => 'get-payment-status',
            't-f-14-19_request-timestamp' => gmdate('Y-m-d H:i:s'),
            's-f-1-36_merchant-agreement-code' => $_helperConfiguration->getMerchantAgreement($this->getStoreId()),
            's-f-1-30_software' => 'Magento',
            's-f-1-10_software-version' => $_helper->_sanitise(Mage::getVersion(), 10, true),
            'i-f-1-11_interface-version' => '3',

            's-f-1-30_payment-method-code' => $this->getPaymentMethodCode(),
            'l-f-1-20_transaction-number' => $this->getTransactionNumber()

        );

        $this->_fields = $_fields;

        return parent::prepareData();
    }

    public function setPaymentMethodCode($_paymentMethodCode)
    {
        $this->_paymentMethodCode = $_paymentMethodCode;

        return $this;
    }

    protected function getPaymentMethodCode()
    {
        return $this->_paymentMethodCode ? $this->_paymentMethodCode : '';
    }

    public function setTransactionNumber($_transactionNumber)
    {
        $this->_transactionNumber = $_transactionNumber;

        return $this;
    }

    protected function getTransactionNumber()
    {
        return $this->_transactionNumber ? $this->_transactionNumber : '';
    }
}