<?php

class Verifone_VerifonePayment_Model_Resource_Order_Process_Status extends Mage_Core_Model_Resource_Db_Abstract
{
    /**
     * Model Initialization
     *
     */
    protected function _construct()
    {
        $this->_init('VerifonePayment/order_process_status', 'entity_id');
    }

    /**
     * @param $orderIncrementId
     *
     * @return bool
     */
    public function lockOrder($orderIncrementId)
    {
        $readConnection = $this->getReadConnection();
        $result = false;
        try {
            $this->beginTransaction();
            $findQuery = $readConnection->select()
                ->from($this->getMainTable())
                ->where('order_id = ?', $orderIncrementId);
            if ($readConnection->fetchOne($findQuery)) {
                $result = (bool)$this->_getWriteAdapter()
                    ->update(
                        $this->getMainTable(),
                        ['under_process' => 1],
                        ['under_process = ?' => 0, 'order_id = ?' => $orderIncrementId]
                    );
            } else {
                $result = (bool)$this->_getWriteAdapter()
                    ->insert($this->getMainTable(), ['order_id' => $orderIncrementId, 'under_process' => 1]);
            }
            $this->commit();
        } catch (Exception $exception) {
            $this->rollBack();
        }

        return $result;
    }

    /**
     * @param $orderIncrementId
     *
     * @return bool
     */
    public function unlockOrder($orderIncrementId)
    {
        $result = false;
        try {
            $this->beginTransaction();
            $result = (bool)$this->_getWriteAdapter()
                ->update(
                    $this->getMainTable(),
                    ['under_process' => 0],
                    ['under_process = ?' => 1, 'order_id = ?' => $orderIncrementId]
                );
            $this->commit();
        } catch (Exception $exception) {
            $this->rollBack();
        }

        return $result;
    }
}
