<?php

class Verifone_VerifonePayment_Model_UrlStatusChecker
{
    private $responseStatusCode;

    private $responseBody;

    /**
     * @param string $url
     *
     * @return string[]
     */
    public function requestUrlStatus($url)
    {
        $ch = $this->createCurlHandler($url);
        $output = $this->sendRequest($ch);
        $this->prepareResponseStatusCode($ch);
        $this->prepareResponseBody($ch, $output);
        $this->closeConnection($ch);
    }

    /**
     * @param object $ch
     *
     * @type integer
     */
    public function getResponseStatusCode()
    {
        return $this->responseStatusCode;
    }

    /**
     * @param object $ch
     * @param string $output
     *
     * @type string
     */
    public function getResponseBody()
    {
        return $this->responseBody;
    }

    /**
     * @param $url
     *
     * @return object
     */
    private function createCurlHandler($url)
    {
        $ch = \curl_init($url);
        \curl_setopt($ch, CURLOPT_HEADER, true);    // we want headers
        \curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
        \curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        \curl_setopt($ch, CURLOPT_TIMEOUT, 10);

        return $ch;
    }

    /**
     * @param object $ch
     *
     * @return string
     */
    private function sendRequest($ch)
    {
        return \curl_exec($ch);
    }

    /**
     * @param object $ch
     *
     * @type integer
     */
    private function prepareResponseStatusCode($ch)
    {
        $this->responseStatusCode = \curl_getinfo($ch, CURLINFO_HTTP_CODE);
    }

    /**
     * @param object $ch
     * @param string $output
     *
     * @type string
     */
    private function prepareResponseBody($ch, $output)
    {
        $headerSize = \curl_getinfo($ch, CURLINFO_HEADER_SIZE);
        $this->responseBody = substr($output, $headerSize);
    }

    /**
     * @param object $ch
     *
     * @type void
     */
    private function closeConnection($ch)
    {
        \curl_close($ch);
    }
}
