<?php


class Verifone_VerifonePayment_Adminhtml_Verifone_RefreshController extends Mage_Adminhtml_Controller_Action
{
    public function indexAction()
    {
        $websites = Mage::app()->getWebsites();
        $responses = array();
        $currentStore = Mage::app()->getStore()->getId();

        /** @var Mage_Core_Model_Website $website */
        foreach ($websites as $website) {
            /** @var Mage_Core_Model_Store $defaultStore */
            $defaultStore = $website->getDefaultStore();

            Mage::app()->setCurrentStore($defaultStore->getId());

            if (!Mage::getStoreConfig('payment/VerifonePayment/active')) {
                continue;
            }

            $_api = Mage::getModel('VerifonePayment/api_s2s_listPaymentMethods');

            $paymentsGateResp = $_api->sendRequest()->getFormatedResponse();
            $_api->clearPreparedFields();


            if (isset($paymentsGateResp['s-f-1-30_error-message']) && $paymentsGateResp['s-f-1-30_error-message'] != '') {
                $responses['s-f-1-30_error-message'] = $paymentsGateResp['s-f-1-30_error-message'];
            }

            $responses[$website->getId()] = $paymentsGateResp;

            $this->checkConfiguration($website->getId());
        }

        Mage::app()->setCurrentStore($currentStore);

        echo $vPaymentsModel = Mage::getModel('VerifonePayment/db_pay_options')->refreshOptions($responses);

    }

    protected function checkConfiguration($websiteId)
    {
        /**
         * Get the resource model
         */
        $resource = Mage::getSingleton('core/resource');

        /**
         * Retrieve the read connection
         */
        $readConnection = $resource->getConnection('core_read');

        /**
         * Get the table name
         */
        $tableName = $resource->getTableName('core/config_data');

        $tables = array(
            'payment/VerifonePayment/cardpaymentsgroup_array' => 'a:1:{s:18:"_1452514030822_822";a:4:{s:8:"position";s:2:"10";s:10:"group_name";s:16:"verifone-default";s:8:"payments";a:2:{i:0;s:4:"visa";i:1;s:11:"master-card";}s:17:"group_description";s:0:"";}}',
            'payment/VerifonePayment/paymentsgroups_array' => 'a:1:{s:18:"_1501939961250_250";a:4:{s:8:"position";s:1:"0";s:10:"group_name";s:16:"verifone-default";s:8:"payments";a:1:{i:0;s:15:"VerifonePayment";}s:17:"group_description";s:0:"";}}'
        );

        foreach ($tables as $table => $value) {
            $sql = "SELECT * FROM `{$tableName}` WHERE `scope` LIKE 'websites' AND `scope_id` = {$websiteId} AND `path` LIKE '$table'";
            $result = $readConnection->fetchRow($sql);

            if (!$result) {
                Mage::getConfig()->saveConfig($table, $value, 'websites', $websiteId);
            }
        }

    }
}