<?php


class Verifone_VerifonePayment_CustomerController extends Mage_Core_Controller_Front_Action
{
    public function preDispatch()
    {
        parent::preDispatch();
        if (!Mage::getSingleton('customer/session')->authenticate($this)) {
            $this->setFlag('', 'no-dispatch', true);
        }
    }

    public function indexAction()
    {
        if (!Mage::getStoreConfig('payment/VerifonePayment/allow_to_save_cc')) {
            $this->_redirect('customer/account');
        }
        $this->loadLayout();
        $this->_initLayoutMessages('customer/session');
        $this->_initLayoutMessages('catalog/session');

        $block = $this->getLayout()->getBlock('verifonepayment.customer.paymentcards');
        if ($block) {
            $block->setRefererUrl($this->_getRefererUrl());
        }

        $this->getLayout()->getBlock('head')->setTitle($this->__('Payment Cards'));
        $this->renderLayout();
    }

    public function savedefaultcardAction()
    {
        if (!Mage::getStoreConfig('payment/VerifonePayment/allow_to_save_cc')) {
            $this->_redirect('customer/account');
        }

        $_id = $this->getRequest()->getParam('_id');

        if (!$_id) {
            Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Card has not been set as default.'));
            return $this->_redirect('*/*');
        }

        $session = Mage::getSingleton('customer/session');
        $_customer = $session->getCustomer();

        $_customer->setVerifoneDefaultCardId($_id);

        if ($_customer->save()) {
            Mage::getSingleton('core/session')->addSuccess(Mage::helper('VerifonePayment')->__('Card has been set as default.'));
            return $this->_redirect('*/*');
        }

        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Card has not been set as default.'));

        return $this->_redirect('*/*');
    }

    public function addcardAction()
    {
        if (!Mage::getStoreConfig('payment/VerifonePayment/allow_to_save_cc')) {
            $this->_redirect('customer/account');
        }

        try {

            $this->getResponse()
                ->setHeader('Content-type', 'text/html; charset=utf8')
                ->setBody($this->getLayout()
                    ->createBlock('VerifonePayment/redirect')
                    ->setApiModel('VerifonePayment/api_paymentinterface_addNewCard')
                    ->toHtml());

        } catch (Exception $e) {

            Mage::getSingleton('core/session')->addError($e->getMessage());

            return $this->_redirect('*/*');
        }
    }

    public function addcardresponsesuccessAction()
    {
        $_request = $this->getRequest();
        $_signedFormData = $_request->getParams();

        Mage::dispatchEvent('verifone_paymentinterface_send_request_after', array(
            '_class' => get_class($this),
            '_response' => $_signedFormData
        ));

        Mage::getSingleton('core/session')->addSuccess(Mage::helper('VerifonePayment')->__('Your card has been successfully added.'));

        return $this->_redirect('*/*');
    }

    public function addcardresponserejectedAction()
    {
        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Your card has been rejected.'));

        return $this->_redirect('*/*');
    }

    public function addcardresponsecancelAction()
    {
        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Card adding canceled'));

        return $this->_redirect('*/*');
    }

    public function addcardresponseexpiredAction()
    {
        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Your card has expired.'));

        return $this->_redirect('*/*');
    }

    public function addcardresponseerrorAction()
    {
        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Server error, please try again later.'));

        return $this->_redirect('*/*');
    }

    public function removecardAction()
    {
        if (!Mage::getStoreConfig('payment/VerifonePayment/allow_to_save_cc')) {
            $this->_redirect('customer/account');
        }
        $_id = $this->getRequest()->getParam('_id');

        $_apiRemoveSavedPaymentMethods = Mage::getModel('VerifonePayment/api_s2s_removeSavedPaymentMethod');

        $_savedPaymentMethodsResponse = $_apiRemoveSavedPaymentMethods->setSavedPaymentMethodId($_id)
            ->sendRequest()
            ->getFormatedResponse();

        $_removed = isset($_savedPaymentMethodsResponse["l-t-1-10_removed-count"]) ? $_savedPaymentMethodsResponse["l-t-1-10_removed-count"] : 0;

        if ($_removed) {
            Mage::getModel('VerifonePayment/db_pay_saved')->removeByGateMethodId($_id);

            Mage::getSingleton('core/session')->addSuccess(Mage::helper('VerifonePayment')->__('Card has been successfully removed.'));
            return $this->_redirect('*/*');
        }

        Mage::getSingleton('core/session')->addError(Mage::helper('VerifonePayment')->__('Server error, please try again later.'));
        return $this->_redirect('*/*');
    }
}