var Grouper = Class.create();

Grouper.prototype = {
    options: {
        _serialized_data: '',
        _method_field_prefix: 'p_method_',
        _method_code: '',
        _gate_code: '',
        _groups_data: null,
        _method_group: null,
        _default_group_name: 'verifone-default',
        _fieldset_styles: null,
        _label_styles: null,
        _select_styles: null,
        _option_styles: null,
        _prefix: '',
        _serialized_saved_cards: '',
        _saved_cards: null,
        _isCard: '0'
    },
    initialize: function (options) {
        this.options = Object.extend(this.options, options);

        if (!this.isJson(this.options._serialized_data)) {
            return;
        }

        this.run();
        this.checkCurrentSelection();
    },
    run: function () {
        var _gateCode = this.options._gate_code;
        var _methodGroup = this.getMethodGroup(_gateCode);
        if (this.getMethodGroupName(_methodGroup) == this.options._default_group_name) {
            return;
        }

        this.addMethodOption(_methodGroup);
    },
    addCardOption: function (_card) {
        var _cardId = _card.value['l-t-1-20_payment-method-id'];
        var _cardCode = _card.value['s-t-1-30_payment-method-code'];
        var _cardTitle = _card.value['s-t-1-30_payment-method-title'];
        var _isDefault = _card.value['is_default'];

        var $_methodOption = new Element(
            'option', {
                id: this.options._method_field_prefix + 'verifone_saved_cc_' + _cardId,
                name: 'payment[method]',
                title: _cardTitle,
                value: _cardCode != 'VerifonePayment' ? this.getMethodInput().value.replace(this.options._gate_code, _cardCode) : this.getMethodInput().value
            }).update(_cardTitle);

        if (_isDefault) {
            $_methodOption.selected = 'selected';
        }

        return $_methodOption;
    },
    isSavedCard: function (_id) {
        var _isSavedCard = false;
        var _savedCards = this.getSavedCards(false);

        $H(_savedCards).each(function (_card) {
            if (this.options._method_field_prefix + 'verifone_saved_cc_' + _card.key == _id) {
                _isSavedCard = _card;
                throw $break;
            }
        }.bind(this));

        return _isSavedCard;
    },
    addMethodOption: function (_methodGroup) {
        var $_methodInput = this.getMethodInput();

        var $_selectBox = this.getSelectBox(_methodGroup);


        if (!this.isCard()) {
            var $_methodOption = new Element(
                'option', {
                    id: $_methodInput.id,
                    name: $_methodInput.name,
                    title: this.options._prefix + $_methodInput.title,
                    value: $_methodInput.value,
                    selected: $_methodInput.checked
                }).update(this.options._prefix + $_methodInput.title);


            $_selectBox.insert({
                bottom: $_methodOption
            });
        }

        $_selectBox.observe('change', function (event) {
            var _selectedId = $_selectBox[$_selectBox.selectedIndex].id;
            if (_selectedId == $_methodInput.id) {
                var _code = $_methodInput.value;
                var $_selectBoxDd = $_selectBox.up().next();
                var $_paymentForm = $('payment_form_' + _code).clone(true);

                $_paymentForm.id = 'payment_form_' + _methodGroup.key;

                $_selectBoxDd.update($_paymentForm);

                payment.switchMethod(_methodGroup.key);

                return;
            }

            var _card = this.isSavedCard(_selectedId);

            if (_card) {
                var $_selectBoxDd = $_selectBox.up().next();
                var $_paymentForm = this.createUlElementForCard(_card);

                $_paymentForm.id = 'payment_form_' + _methodGroup.key;

                $_selectBoxDd.update($_paymentForm);

                payment.switchMethod(_methodGroup.key);

                return;
            }
        }.bind(this));

        $_methodInput.up().remove();

        return this;
    },
    getSelectBox: function (_methodGroup) {
        if (!this.isSelectBoxExists(_methodGroup.key)) {
            this.createMethodGroup(_methodGroup.key, this.getMethodGroupName(_methodGroup));
        }

        return $(_methodGroup.key);
    },
    isSelectBoxExists: function (_methodGroupId) {
        return $(_methodGroupId);
    },
    createMethodGroup: function (_methodGroupId, _title) {
        var $_selectBox = this.createSelectBox(_methodGroupId);
        var $_groupTitleInput = new Element(
            'input', {
                id: 'p_method_' + _methodGroupId,
                name: 'payment[method]',
                type: 'radio',
                'class': 'radio',
                title: _title,
                autocomplete: 'off',
                onclick: "payment.switchMethod('" + _methodGroupId + "')"
            }
        );

        var $_groupTitleLabel = new Element(
            'label', {
                for: 'p_method_' + _methodGroupId
            }
        ).update(_title);

        var $_methodInput = this.getMethodInput();
        var _code = $_methodInput.value;

        var $_paymentForm = $('payment_form_' + _code).clone(true);

        if (this.isJson(this.options._serialized_saved_cards)) {

            var _savedCards = this.getSavedCards();

            $_paymentForm = null;
            $H(_savedCards).each(function (_card) {
                if (!$_paymentForm) {
                    $_paymentForm = this.createUlElementForCard(_card);
                }

                if (_card.value['is_default']) {
                    $_paymentForm = this.createUlElementForCard(_card);
                    throw $break;
                }
            }.bind(this));
        }

        $_paymentForm.id = 'payment_form_' + _methodGroupId;

        var $_dt = new Element('dt');
        var $_dd = new Element('dd');

        $_dd.insert($_paymentForm);

        var $_methodListTitle = this.getMethodListTitle();

        $_methodListTitle
            .insert({before: $_dt})
            .insert({before: $_dd});

        $_dt.insert($_groupTitleInput)
            .insert($_groupTitleLabel)
            .insert($_selectBox);

        this.disableSelectBox($_selectBox, $_groupTitleInput.id);
    },
    disableSelectBox: function ($_selectBox, _exception_id) {
        $('co-payment-form').observe('click', function (event) {
            var $_element = $(event.target);

            if ($_element.match('input[type=radio]')) {
                if ($_element.id == _exception_id) {
                    $_selectBox.disabled = false;
                    return;
                }
                $_selectBox.disabled = 'disabled';
            }
        });
    },
    createSelectBox: function (_methodGroupId) {
        var $_selectBox = new Element(
            'select', {
                id: _methodGroupId,
                name: 'payment[method]',
                disabled: 'disabled'
            }
        ).setStyle(this.options._select_styles);

        if (this.isJson(this.options._serialized_saved_cards)) {
            var _savedCards = this.getSavedCards(true);

            $H(_savedCards).each(function (_card) {
                var $_methodOption = this.addCardOption(_card);

                $_selectBox.insert($_methodOption);
            }.bind(this));

            if (this.isCard()) {

            }
        }

        return $_selectBox;
    },
    createUlElementForCard: function (_card) {
        var _cardId = parseInt(_card.value['l-t-1-20_payment-method-id']);
        _cardId = !isNaN(_cardId) ? _cardId : '';
        var _cardCode = _card.value['s-t-1-30_payment-method-code'];
        //var _cardTitle = _card.value['s-t-1-30_payment-method-title'];

        var $_paymentForm;
        var $_methodInput = this.getMethodInput();

        [
            'vp_visa', 'vp_master-card',
            'vp_amex', 'vp_diners',
            'vp-recurring_visa', 'vp-recurring_master-card',
            'vp-recurring_amex', 'vp-recurring_diners'
        ].each(function (_code) {
                if ($_methodInput && $_methodInput.value == _code) {
                    $_paymentForm = $('payment_form_' + _code).clone(true);
                    throw $break;
                }
                if ($('payment_form_' + _code)) {
                    $_paymentForm = $('payment_form_' + _code).clone(true);
                    throw $break;
                }
            }.bind(this));

        if ($_paymentForm) {
            //$_paymentForm.id = 'payment_form_' + _cardPaymentCode + '_' + _cardId;
            var $_saveCheckbox = $_paymentForm.select('input[name="payment[i-t-1-1_save-payment-method]"]').first();

            if ($_saveCheckbox && _cardId) {
                $_saveCheckbox.up().remove();
            }

            var $_cardTypeInput = $_paymentForm.select('input[name="payment[s-t-1-30_payment-method-code]"]').first();
            if ($_cardTypeInput) {
                $_cardTypeInput.value = _cardCode;
                $_cardTypeInput.up().insert(
                    new Element('input', {
                        type: 'hidden',
                        name: 'payment[l-t-1-20_saved-payment-method-id]',
                        value: _cardId
                    })
                );
            }
            return $_paymentForm;
        }

        return null;
    },
    getMethodListElements: function () {
        var $_title = this.getMethodListTitle();
        var $_content = this.getMethodListContent();

        return [$_title, $_content];
    },
    getMethodListContent: function () {
        var $_methodListTitle = this.getMethodListTitle();

        return $_methodListTitle.next();
    },
    getMethodName: function () {
        $_methodListTitle = this.getMethodListTitle();
        $_methodTitleLabel = $_methodListTitle.select('label');

        return $_methodTitleLabel.first().innerText;
    },
    getMethodListTitle: function () {
        var $_methodInput = this.getMethodInput();

        return $_methodInput.up();
    },
    getMethodInput: function () {
        var $_methodInput = $(this.options._method_field_prefix + this.options._method_code);

        return $_methodInput;
    },
    getMethodGroupName: function (_methodGroup) {
        return _methodGroup.value.group_name;
    },
    getMethodGroup: function (_gateCode) {
        var _groupsData = this.getGroupsData();
        $H(_groupsData).each(function (element) {
            element.value.payments.each(function (_code) {
                if (_gateCode == _code) {

                    this.options._method_group = element;
                    throw $break;
                }
            }.bind(this));
        }.bind(this));
        return this.options._method_group;
    },
    setGroupsData: function () {
        if (!this.options._groups_data && this.isJson(this.options._serialized_data)) {
            this.options._groups_data = JSON.parse(this.options._serialized_data);
        }
    },
    getGroupsData: function () {
        if (!this.options._groups_data) {
            this.setGroupsData();
        }

        if (this.options._groups_data) {
            return this.options._groups_data;
        }

        return null;
    },
    setSavedCards: function () {
        if (!this.options._saved_cards && this.isJson(this.options._serialized_saved_cards)) {
            this.options._saved_cards = JSON.parse(this.options._serialized_saved_cards);
        }
    },
    getSavedCards: function (_force) {
        if (!this.options._saved_cards || _force) {
            this.setSavedCards();
        }

        if (this.options._saved_cards) {
            return this.options._saved_cards;
        }

        return null;
    },
    isJson: function (serialized) {
        try {
            JSON.parse(serialized);
        } catch (e) {
            return false;
        }
        return true;
    },
    isCard: function () {
        return this.options._isCard;
    },
    checkCurrentSelection: function () {
        var $_methodInput = this.getMethodInput();
        if ($_methodInput && $_methodInput.selected) {
            var $_parentSelect = $_methodInput.up();
            var $_selectBoxDd = $_parentSelect.up().next();
            if ($_selectBoxDd) {
                var _code = $_methodInput.value;
                if (_code) {
                    var $_paymentForm = $('payment_form_' + _code).clone(true);
                    if ($_paymentForm) {
                        var _gateCode = this.options._gate_code;
                        var _methodGroup = this.getMethodGroup(_gateCode);
                        $_paymentForm.id = 'payment_form_' + _methodGroup.key;
                        $_selectBoxDd.update($_paymentForm);
                    }
                }
            }
        }
    }
}
